#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <cmath>
#include <string>
#include <bits/stdc++.h>
#include <strstream>
#include <queue>

#define USE_MATH_DEFINES

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k, x, i, l, pp, j;
    cin>>n>>k>>x;
    int*a=new int [n];
    if (k==3) {
        if ((n<=2)||((n>4)&&(x<=1))) {
            cout<<-1;
            return 0;
        }
        else if (n==3) {
            l=1;
            for (i=1; i<=n; i++) {
                cout<<l<<" ";
                l=l+x;
            }
        }
        else if (x>k) {
            for (i=1; i<=k; i++) {
                cout<<i<<" ";
            }
            l=k+x;
            for (i=k+1; i<=n-1; i++) {
                cout<<x<<" ";
            }
            cout<<l;
        }
        else {
            for (i=1; i<=3; i++) {
                cout<<1<<" ";
            }
            cout<<x+1<<" ";
            for (i=5; i<=n; i++) {
                cout<<x;
                if (i<n) {
                    cout<<" ";
                }
            }
        }
        return 0;
    }
    if (k==n) {
        if ((n<=2)||(x==1)) {
            cout<<"-1";
            return 0;
        }
        else {
            cout<<1<<" ";
            cout<<x+1<<" ";
            for (i=1; i<=n-3; i++) {
                cout<<x+2<<" ";
            }
            cout<<2*x+1;
        }
        return 0;
    }

    else {  if (k<=n-1) {
        cout<<1<<" ";
        for (i=1; i<n-k; i++) {
            cout<<2<<" ";
        }
        for (i=1; i<k; i++) {
            cout<<1+x<<" ";
        }
        cout<<1+x;
    }
            else {pp=n-1;
            l=1;
            cout<<l<<" ";
            for (i=2; i<=n; i++) {
                if (pp<=k) {
                    k=k-pp;
                    l=l+x;
                }
                else {
                    for (j=i+1; j<n-k; j++) {
                        cout<<l+1<<" ";
                    }
                    for (j=1; j<k; j++) {
                        cout<<l+x<<" ";
                    }
                    cout<<l+x;
                    return 0;
                }
                cout<<l;
                pp=pp-1;
                if (i!=n) {
                    cout<<" ";
                }

            }
    }
    }
    return 0;
}